using AC2RE.Definitions;
using LandblockExtraction.DatEngine;
using LandblockExtraction.Tools;
using System.Numerics;

namespace LandblockExtraction.LandBlockExtractor {
    public class LandBlockExtrator {
        private PortalEngine portalEngine;
        private CellEngine cellEngine;

        private readonly int NumberLandBlocks = 255;
        private readonly int BlockSize = 17;
        private readonly int cellSize = 8;

        public LandBlockExtrator(PortalEngine portalEngine, CellEngine cellEngine) {
            this.portalEngine = portalEngine;
            this.cellEngine = cellEngine;
        }

        public BlockStruct? GetBlock(int landX, int landY) {
                    CellId landBlockId = new CellId((byte)landX, (byte)landY, 0xFF, 0xFF);
                    var landBlock = cellEngine.GetLandBlockData(landBlockId.id);
                    if (landBlock == null) return null;

                    return GenerateBlockStructByData(landBlock, landX, landY);
        }

        public BlockStruct GenerateBlockStructByData(CLandBlockData blockData, int landX, int landY) {
            BlockStruct blockStruct = new BlockStruct();
            for (int y = 0; y < BlockStruct.BlockSize; y++) {
                for (int x = 0; x < BlockStruct.BlockSize; x++) {
                    var indice = y * BlockStruct.BlockSize + x;
                    blockStruct.verticesStruct.position[indice] = GenerateVertexPosition(landX, landY, x, y, blockData.heights[indice]);
                    blockStruct.verticesStruct.color[indice] = GenerateVertexColor(blockData.cellInfos[indice]);
                    blockStruct.verticesStruct.farcolor[indice] = GenerateVertexFarColor(blockData.cellInfos[indice]);
                    blockStruct.GenerateIndices();
                }
            }

            return blockStruct;
        }
        private Vector3 GenerateVertexPosition(int landx, int landy, int x, int y, byte height) {
            int tmpx = (landx * BlockSize + y) * cellSize;
            int tmpy = (BlockSize * NumberLandBlocks * cellSize) - ((landy * BlockSize + x) * cellSize) - 1;
            var newX = (tmpx - (NumberLandBlocks * BlockSize * cellSize / 2));
            var newY = (tmpy - ((NumberLandBlocks * BlockSize * cellSize) - (NumberLandBlocks * BlockSize * cellSize / 2) - 1));

            return new Vector3(newX, portalEngine.landScapeDefs.landHeightTable[height], newY);
        }
        private Vector4 GenerateVertexColor(uint cellInfo) {
            var terrain = MathOperations.GetTerrainInCellInfo(cellInfo);

            foreach (var terrainType in portalEngine.cTerrainDesc.terrains) {
                if (terrainType.terrainIndex == terrain) {
                    foreach (var surfaceIndex in portalEngine.cSurfaceDesc.surfaces) {
                        if (surfaceIndex.surfIndex == terrainType.surfaceInfo) {
                            var color = surfaceIndex.terrainMaterials.First().vertexColor.First().vertexColor;
                            return MathOperations.RGBAColorToVector4(color);
                        }
                    }
                }
            }

            return Vector4.One;
        }
        private Vector4 GenerateVertexFarColor(uint cellInfo) {
            var terrain = MathOperations.GetTerrainInCellInfo(cellInfo);

            foreach (var terrainType in portalEngine.cTerrainDesc.terrains) {
                if (terrainType.terrainIndex == terrain) {
                    foreach (var surfaceIndex in portalEngine.cSurfaceDesc.surfaces) {
                        if (surfaceIndex.surfIndex == terrainType.surfaceInfo) {
                            var color = surfaceIndex.terrainMaterials.First().vertexColor.First().farVertexColor;
                            return MathOperations.RGBAColorToVector4(color);
                        }
                    }
                }
            }

            return Vector4.One;
        }
    }
}
